Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/FilterContent.cs	(revision 10252)
@@ -12,4 +12,17 @@
   class FilterContent : Item
   {
+
+    private readonly IFilterLogic filterLogic;
+    public FilterContent(IFilterLogic theFilterLogic)
+    {
+      filterLogic = theFilterLogic;
+    }
+
+    public IFilterLogic FilterLogic
+    {
+      get {
+        return filterLogic;
+      }
+    }
 
     public FilterContent(FilterContent content, Cloner cloner)
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramContent.cs	(revision 10252)
@@ -13,8 +13,23 @@
   class HistogramContent : Item
   {
+
+    private readonly IHistogramLogic histogramLogic;
+    public HistogramContent(IHistogramLogic theHistogramLogic)
+    {
+      histogramLogic = theHistogramLogic;
+    }
+
     public HistogramContent(HistogramContent content, Cloner cloner)
       : base(content, cloner)
     {
 
+    }
+
+    public IHistogramLogic HistogramLogic
+    {
+      get
+      {
+        return histogramLogic;
+      }
     }
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartContent.cs	(revision 10252)
@@ -12,8 +12,23 @@
   class LineChartContent : Item
   {
+
+    private readonly ILineChartLogic lineChartLogic;
+    public LineChartContent(ILineChartLogic theLineChartLogic)
+    {
+      lineChartLogic = theLineChartLogic;
+    }
+
     public LineChartContent(LineChartContent content, Cloner cloner)
       : base(content, cloner)
     {
 
+    }
+
+    public ILineChartLogic LineChartLogic
+    {
+      get
+      {
+        return lineChartLogic;
+      }
     }
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10252)
@@ -6,5 +6,5 @@
 namespace HeuristicLab.DataPreprocessing.Implementations
 {
-  public class LineChartLogic:ILineChartLgic
+  public class LineChartLogic:ILineChartLogic
   {
   }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsContent.cs	(revision 10252)
@@ -12,8 +12,23 @@
   class StatisticsContent : Item
   {
+
+    private readonly IStatisticsLogic statisticsLogic;
+    public StatisticsContent(IStatisticsLogic theStatisticsLogic)
+    {
+      statisticsLogic = theStatisticsLogic;
+    }
+
     public StatisticsContent(StatisticsContent content, Cloner cloner)
       : base(content, cloner)
     {
 
+    }
+
+    public IStatisticsLogic StatisticsLogic
+    {
+      get
+      {
+        return statisticsLogic;
+      }
     }
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10251)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10252)
@@ -12,4 +12,19 @@
   class TransformationContent : Item
   {
+
+    private readonly ITransformationLogic transformationLogic;
+    public TransformationContent(ITransformationLogic theTransformationLogic)
+    {
+      transformationLogic = theTransformationLogic;
+    }
+
+    public ITransformationLogic TransformationLogic
+    {
+      get
+      {
+        return transformationLogic;
+      }
+    }
+
     public TransformationContent(TransformationContent content, Cloner cloner)
       : base(content, cloner)