Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataPreprocessingView.Designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataPreprocessingView.Designer.cs	(revision 10253)
+++ 	(revision )
@@ -1,67 +1,0 @@
-﻿namespace HeuristicLab.DataPreprocessing {
-  partial class DataPreprocessingView {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.label1 = new System.Windows.Forms.Label();
-      this.button1 = new System.Windows.Forms.Button();
-      this.SuspendLayout();
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(58, 56);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(62, 13);
-      this.label1.TabIndex = 0;
-      this.label1.Text = "Hello World";
-      // 
-      // button1
-      // 
-      this.button1.Location = new System.Drawing.Point(61, 88);
-      this.button1.Name = "button1";
-      this.button1.Size = new System.Drawing.Size(215, 23);
-      this.button1.TabIndex = 1;
-      this.button1.Text = "Write Ones everywhere in DataSet";
-      this.button1.UseVisualStyleBackColor = true;
-      this.button1.Click += new System.EventHandler(this.button1_Click);
-      // 
-      // DataPreprocessingView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.button1);
-      this.Controls.Add(this.label1);
-      this.Name = "DataPreprocessingView";
-      this.Size = new System.Drawing.Size(404, 203);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.Button button1;
-  }
-}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataPreprocessingView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataPreprocessingView.cs	(revision 10253)
+++ 	(revision )
@@ -1,82 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Optimization;
-using HeuristicLab.Problems.DataAnalysis;
-
-namespace HeuristicLab.DataPreprocessing {
-  [View("Data Preprocessing View")]
-  [Content(typeof(IPreprocessingContext), false)]
-  [Content(typeof(PreprocessingContext), true)]
-  public partial class DataPreprocessingView : ItemView {
-
-    public new IPreprocessingContext Content {
-      get { return (IPreprocessingContext)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public DataPreprocessingView() {
-      InitializeComponent();
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
-
-    private void button1_Click(object sender, System.EventArgs e) {
-
-      IPreprocessingData Data = Content.Data;
-
-      foreach (string variable in Data.VariableNames) {
-        for (int j = 0; j < Data.Rows; j++) {
-          // assume: all double
-          Data.SetCell(variable, j, 1.0);
-        }
-      }
-
-      MessageBox.Show("Success, now cloning... ");
-
-      Dataset dataset = Data.ExportToDataset();
-      var variables = new CheckedItemList<StringValue>(Data.VariableNames.Select(s => new StringValue(s))).AsReadOnly();
-
-      var cloner = new Cloner();
-
-      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.Dataset, dataset);
-      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TrainingPartition, Data.TrainingPartition);
-      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TestPartition, Data.TestPartition);
-      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.InputVariables, variables);
-      if (Content.Algorithm != null) {
-        cloner.RegisterClonedObject(Content.Algorithm.Runs, new RunCollection { OptimizerName = Content.Algorithm.Name });
-      }
-
-      var item = cloner.Clone(Content.ParentItem);
-      MainFormManager.MainForm.ShowContent(item);
-    }
-  }
-}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs	(revision 10253)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs	(revision 10254)
@@ -1,20 +1,15 @@
 ﻿using System;
 using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
 using System.Linq;
-using System.Text;
 using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.DataPreprocessing.Implementations;
-using HeuristicLab.MainForm;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
 using HeuristicLab.Data;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
 
-namespace HeuristicLab.DataPreprocessing
-{
+namespace HeuristicLab.DataPreprocessing {
   [View("DataPreprocessing View")]
   [Content(typeof(PreprocessingContext), true)]
@@ -29,5 +24,5 @@
 
       InitializeContents();
-      
+
     }
 
@@ -36,16 +31,16 @@
       ListViewItem listViewItem = new ListViewItem();
 
-        listViewItem.Text = item.ToString();
-        //listViewItem.ToolTipText = item.ItemName + ": " + item.ItemDescription;
-        //itemsListView.SmallImageList.Images.Add(content.);
-        //listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
-        //listViewItem.Tag = item;
+      listViewItem.Text = item.ToString();
+      //listViewItem.ToolTipText = item.ItemName + ": " + item.ItemDescription;
+      //itemsListView.SmallImageList.Images.Add(content.);
+      //listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+      //listViewItem.Tag = item;
       return listViewItem;
     }
 
     private void InitializeContents() {
-      dataGridContent = new DataGridContent(new DataGridLogic(this.Content));
+      dataGridContent = new DataGridContent(new DataGridLogic(Content != null ? this.Content.Data : null));
 
-      listViewItemItemMapping = new Dictionary<ListViewItem,IItem>();
+      listViewItemItemMapping = new Dictionary<ListViewItem, IItem>();
       ListViewItem contentListViewItem = CreateListViewItem(dataGridContent);
       listViewItemItemMapping[contentListViewItem] = dataGridContent;
@@ -54,6 +49,6 @@
     }
 
-    public new PreprocessingData Content {
-      get { return (PreprocessingData)base.Content; }
+    public new PreprocessingContext Content {
+      get { return (PreprocessingContext)base.Content; }
       set { base.Content = value; }
     }
@@ -61,9 +56,8 @@
     private void listView1_SelectedIndexChanged(object sender, EventArgs e) {
 
-        if (contentListView.SelectedItems.Count > 0)
-        {
-            ListViewItem listViewItem = (ListViewItem)contentListView.SelectedItems[0];
-            this.viewHost.Content = listViewItemItemMapping[listViewItem];
-        }
+      if (contentListView.SelectedItems.Count > 0) {
+        ListViewItem listViewItem = (ListViewItem)contentListView.SelectedItems[0];
+        this.viewHost.Content = listViewItemItemMapping[listViewItem];
+      }
     }
 
@@ -73,46 +67,34 @@
     }
 
-    private void tryOutAlgorithmButton_Click(object sender, EventArgs e)
-    {
+    private void tryOutAlgorithmButton_Click(object sender, EventArgs e) {
+      IPreprocessingData Data = Content.Data;
 
+      foreach (string variable in Data.VariableNames) {
+        for (int j = 0; j < Data.Rows; j++) {
+          // assume: all double
+          Data.SetCell(variable, j, 1.0);
+        }
+      }
+
+      MessageBox.Show("Success, now cloning... ");
+
+      Dataset dataset = Data.ExportToDataset();
+      var variables = new CheckedItemList<StringValue>(Data.VariableNames.Select(s => new StringValue(s))).AsReadOnly();
+
+      var cloner = new Cloner();
+
+      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.Dataset, dataset);
+      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TrainingPartition, Data.TrainingPartition);
+      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TestPartition, Data.TestPartition);
+      cloner.RegisterClonedObject(Content.DataAnalysisProblemData.InputVariables, variables);
+      if (Content.Algorithm != null) {
+        cloner.RegisterClonedObject(Content.Algorithm.Runs, new RunCollection { OptimizerName = Content.Algorithm.Name });
+      }
+
+      var item = cloner.Clone(Content.ParentItem);
+
+      MainFormManager.MainForm.ShowContent(item);
     }
-
-    //private void button1_Click(object sender, System.EventArgs e)
-    //{
-
-    //    IPreprocessingData Data = Content.Data;
-
-    //    foreach (string variable in Data.VariableNames)
-    //    {
-    //        for (int j = 0; j < Data.Rows; j++)
-    //        {
-    //            // assume: all double
-    //            Data.SetCell(variable, j, 1.0);
-    //        }
-    //    }
-
-    //    MessageBox.Show("Success, now cloning... ");
-
-    //    Dataset dataset = Data.ExportToDataset();
-    //    var variables = new CheckedItemList<StringValue>(Data.VariableNames.Select(s => new StringValue(s))).AsReadOnly();
-
-    //    var cloner = new Cloner();
-
-    //    cloner.RegisterClonedObject(Content.DataAnalysisProblemData.Dataset, dataset);
-    //    cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TrainingPartition, Data.TrainingPartition);
-    //    cloner.RegisterClonedObject(Content.DataAnalysisProblemData.TestPartition, Data.TestPartition);
-    //    cloner.RegisterClonedObject(Content.DataAnalysisProblemData.InputVariables, variables);
-
-    //    var item = cloner.Clone(Content.ParentItem);
-
-    //    MainFormManager.MainForm.ShowContent(item);
-
-    //    //var clone = null;
-
-    //}
-
-
   }
 }
 
-    