Index: branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Symbolic/GESymbolicDataAnalysisProblem.cs
===================================================================
--- branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Symbolic/GESymbolicDataAnalysisProblem.cs	(revision 10268)
+++ branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Symbolic/GESymbolicDataAnalysisProblem.cs	(revision 10276)
@@ -51,8 +51,5 @@
     private const string SymbolicExpressionTreeGrammarParameterName = "SymbolicExpressionTreeGrammar";
     private const string SymbolicExpressionTreeInterpreterParameterName = "SymbolicExpressionTreeInterpreter";
-    //private const string MaximumSymbolicExpressionTreeDepthParameterName = "MaximumSymbolicExpressionTreeDepth";
     private const string MaximumSymbolicExpressionTreeLengthParameterName = "MaximumSymbolicExpressionTreeLength";
-    //private const string MaximumFunctionDefinitionsParameterName = "MaximumFunctionDefinitions";
-    //private const string MaximumFunctionArgumentsParameterName = "MaximumFunctionArguments";
     private const string RelativeNumberOfEvaluatedSamplesParameterName = "RelativeNumberOfEvaluatedSamples";
     private const string FitnessCalculationPartitionParameterName = "FitnessCalculationPartition";
@@ -90,16 +87,7 @@
       get { return (IValueParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>)Parameters[SymbolicExpressionTreeInterpreterParameterName]; }
     }
-    //public IFixedValueParameter<IntValue> MaximumSymbolicExpressionTreeDepthParameter {
-    //  get { return (IFixedValueParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeDepthParameterName]; }
-    //}
     public IFixedValueParameter<IntValue> MaximumSymbolicExpressionTreeLengthParameter {
       get { return (IFixedValueParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeLengthParameterName]; }
     }
-    //public IFixedValueParameter<IntValue> MaximumFunctionDefinitionsParameter {
-    //  get { return (IFixedValueParameter<IntValue>)Parameters[MaximumFunctionDefinitionsParameterName]; }
-    //}
-    //public IFixedValueParameter<IntValue> MaximumFunctionArgumentsParameter {
-    //  get { return (IFixedValueParameter<IntValue>)Parameters[MaximumFunctionArgumentsParameterName]; }
-    //}
     public IFixedValueParameter<PercentValue> RelativeNumberOfEvaluatedSamplesParameter {
       get { return (IFixedValueParameter<PercentValue>)Parameters[RelativeNumberOfEvaluatedSamplesParameterName]; }
@@ -143,16 +131,8 @@
     }
 
-    //public IntValue MaximumSymbolicExpressionTreeDepth {
-    //  get { return MaximumSymbolicExpressionTreeDepthParameter.Value; }
-    //}
     public IntValue MaximumSymbolicExpressionTreeLength {
       get { return MaximumSymbolicExpressionTreeLengthParameter.Value; }
     }
-    //public IntValue MaximumFunctionDefinitions {
-    //  get { return MaximumFunctionDefinitionsParameter.Value; }
-    //}
-    //public IntValue MaximumFunctionArguments {
-    //  get { return MaximumFunctionArgumentsParameter.Value; }
-    //}
+
     public PercentValue RelativeNumberOfEvaluatedSamples {
       get { return RelativeNumberOfEvaluatedSamplesParameter.Value; }
@@ -186,8 +166,5 @@
       Parameters.Add(new ValueParameter<GESymbolicExpressionGrammar>(SymbolicExpressionTreeGrammarParameterName, SymbolicExpressionTreeGrammarParameterDescription));
       Parameters.Add(new ValueParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>(SymbolicExpressionTreeInterpreterParameterName, SymoblicExpressionTreeInterpreterParameterDescription));
-      //Parameters.Add(new FixedValueParameter<IntValue>(MaximumSymbolicExpressionTreeDepthParameterName, MaximumSymbolicExpressionTreeDepthParameterDescription));
       Parameters.Add(new FixedValueParameter<IntValue>(MaximumSymbolicExpressionTreeLengthParameterName, MaximumSymbolicExpressionTreeLengthParameterDescription));
-      //Parameters.Add(new FixedValueParameter<IntValue>(MaximumFunctionDefinitionsParameterName, MaximumFunctionDefinitionsParameterDescription));
-      //Parameters.Add(new FixedValueParameter<IntValue>(MaximumFunctionArgumentsParameterName, MaximumFunctionArgumentsParameterDescription));
       Parameters.Add(new FixedValueParameter<IntRange>(FitnessCalculationPartitionParameterName, FitnessCalculationPartitionParameterDescription));
       Parameters.Add(new FixedValueParameter<IntRange>(ValidationPartitionParameterName, ValidationPartitionParameterDescription));
@@ -199,6 +176,4 @@
 
       SymbolicExpressionTreeInterpreterParameter.Hidden = true;
-      //MaximumFunctionArgumentsParameter.Hidden = true;
-      //MaximumFunctionDefinitionsParameter.Hidden = true;
       ApplyLinearScalingParameter.Hidden = true;
 
@@ -232,5 +207,4 @@
     private void InitializeOperators() {
       Operators.AddRange(ApplicationManager.Manager.GetInstances<IIntegerVectorOperator>().OfType<IOperator>());
-      // Operators.AddRange(ApplicationManager.Manager.GetInstances<ISymbolicDataAnalysisExpressionCrossover<T>>());
       Operators.Add(new SymbolicExpressionSymbolFrequencyAnalyzer());
       Operators.Add(new SymbolicDataAnalysisVariableFrequencyAnalyzer());
@@ -246,8 +220,4 @@
 
       RegisterGrammarHandler();
-
-      //MaximumFunctionArguments.ValueChanged += new EventHandler(ArchitectureParameterValue_ValueChanged);
-      //MaximumFunctionDefinitions.ValueChanged += new EventHandler(ArchitectureParameterValue_ValueChanged);
-      //MaximumSymbolicExpressionTreeDepth.ValueChanged += new EventHandler(MaximumSymbolicExpressionTreeDepth_ValueChanged);
     }
 
@@ -263,14 +233,4 @@
     }
 
-    //private void MaximumSymbolicExpressionTreeDepth_ValueChanged(object sender, EventArgs e) {
-    //  if (MaximumSymbolicExpressionTreeDepth != null && MaximumSymbolicExpressionTreeDepth.Value < 3)
-    //    MaximumSymbolicExpressionTreeDepth.Value = 3;
-    //}
-
-    //protected override void OnSolutionCreatorChanged() {
-    //  base.OnSolutionCreatorChanged();
-    //  ParameterizeOperators();
-    //}
-
     protected override void OnEvaluatorChanged() {
       base.OnEvaluatorChanged();
@@ -304,14 +264,4 @@
         op.SymbolicExpressionTreeGrammarParameter.ActualName = SymbolicExpressionTreeGrammarParameter.Name;
       }
-      /*
-      foreach (var op in operators.OfType<ISymbolicExpressionTreeSizeConstraintOperator>()) {
-        op.MaximumSymbolicExpressionTreeDepthParameter.ActualName = MaximumSymbolicExpressionTreeDepthParameter.Name;
-        op.MaximumSymbolicExpressionTreeLengthParameter.ActualName = MaximumSymbolicExpressionTreeLengthParameter.Name;
-      }
-      foreach (var op in operators.OfType<ISymbolicExpressionTreeArchitectureAlteringOperator>()) {
-        op.MaximumFunctionArgumentsParameter.ActualName = MaximumFunctionArgumentsParameter.Name;
-        op.MaximumFunctionDefinitionsParameter.ActualName = MaximumFunctionDefinitionsParameter.Name;
-      }
-      */
       foreach (var op in operators.OfType<IGESymbolicDataAnalysisEvaluator<T>>()) {
         op.ProblemDataParameter.ActualName = ProblemDataParameterName;
@@ -354,13 +304,4 @@
         op.SymbolicDataAnalysisTreeInterpreterParameter.ActualName = SymbolicExpressionTreeInterpreterParameter.Name;
       }
-      /*
-      foreach (var op in operators.OfType<ISymbolicDataAnalysisExpressionCrossover<T>>()) {
-        op.EvaluationPartitionParameter.ActualName = FitnessCalculationPartitionParameter.Name;
-        op.ProblemDataParameter.ActualName = ProblemDataParameter.Name;
-        op.EvaluationPartitionParameter.ActualName = FitnessCalculationPartitionParameter.Name;
-        op.RelativeNumberOfEvaluatedSamplesParameter.ActualName = RelativeNumberOfEvaluatedSamplesParameter.Name;
-        op.EvaluatorParameter.ActualName = EvaluatorParameter.Name;
-      }
-      */
     }
 